rm(list=ls());
source("datahandle.R");
source("engine.R")

EM <- function(n=10,x=cases,inu=1000,itau=300,iD=1000,print=TRUE){ 
  S <- length(unique(x[[1]]$sys))
  numat <- matrix(0,S,S)
  diag(numat) <- rep(inu,S)
  taudata <- rep(itau,S)
  D <- rep(iD,S)
  alpha <- rep(10,S)
  for(i in 1:length(x)){
    x[[i]]$H <- rep(rep(x[[i]]$H,each=2),S)
    x[[i]]$mu <- x[[i]]$H*10
    x[[i]]$P <- t(summatrix(x[[i]]$ms))
  }
  altrace <- as.data.frame(t(1:S))[0,]
  tautrace <- as.data.frame(t(1:S))[0,]
  Dtrace <- as.data.frame(t(1:S))[0,]
  Devtrace <- numeric(0)
  nutrace <- as.data.frame(t(1:(S/2*(S+1))))[0,]
  for(i in 1:n){
    if(i%%100==0) print(i)
    x <- lapply(x,updateMoments,D=D,taudata=taudata,numat=numat)
    nuTau <- EstimV(x)
    taudata <- nuTau$tau
    numat <- nuTau$nu
    h <- EstimA(x)
    x <- h$y
    dev <- sum(extract(x,x$dev))
    pars <- c(nuTau,list(al=h$al,si=h$si,dev=dev))
    D <- pars$si
    if(print) print(pars)
    altrace <- rbind(altrace,as.vector(h$al))
    tautrace <- rbind(tautrace,as.vector(taudata))
    nutrace <- rbind(nutrace,numat[upper.tri(numat,diag=T)])
    Devtrace <- c(Devtrace,dev)
    Dtrace <- rbind(Dtrace,as.vector(D))
  }
  list(data=x,parameters=pars,trace=list(alpha=altrace,tau=tautrace,lambda=nutrace,D=Dtrace,Dev=Devtrace))
}


