## Data should be sorted as: case,system,person(,allele)

mixmat <- function(s,k){
  mat <- matrix(0,4*s,2*s)
  for(i in 1:(4*s)){
    j <- floor(i/4)+1
    if(is.element(i,seq(1,by=4,len=s))){
      mat[i,] <- c(rep(0,2*(j-1)),c(1,0),rep(0,2*(s-j)))
    }
    if(is.element(i,seq(2,by=4,len=s))){     
      mat[i,] <- c(rep(0,2*(j-1)),c(0,1),rep(0,2*(s-j)))
    }
  }
  if(k==1) mat <- mat
  if(k==2) mat <- rbind(matrix(0,2,2*s),mat[1:(4*s-2),])
  mat
}

mixp <- function(p1,p2){
  if(p2[1]==0) return(c(NA,p1))
  else{
  s <- length(p1)/2
  mat1 <- mixmat(s,1)
  mat2 <- mixmat(s,2)
  pbyp <- matrix(0,s*2,2)
  pbyp[,1] <- p1
  pbyp[,2] <- p2
  p <- mat1%*%pbyp%*%c(1,0)+mat2%*%pbyp%*%c(0,1)
  p
}
}

tmat <- function(p){
  if(is.na(p[1])) { ## one contributor
    p <- p[-1]
      s <- length(p)/2
      dimm <- 0
      dimms <- numeric(s)
      for(i in 1:s){
        j <- (1:2)+2*(i-1)
        dimms[i] <- length(unique(p[j]))
        dimm <- dimm+dimms[i]
      }
      tmat <- matrix(0,dimm,2*s)
      for(i in 1:s){
        ttemp <- matrix(0,dimms[i],2)
        if(dimms[i]==2) diag(ttemp) <- rep(1,2)
        else ttemp <- c(1,1)
        tmat[(1:dimms[i])+sum(dimms[0:(i-1)]),(1:2)+2*(i-1)] <- ttemp
      }
    }
  else { ## two contributors
    s <- length(p)/4
    dimm <- 0
    dimms <- numeric(s)
    for(i in 1:s){
      j <- (1:4)+4*(i-1)
      dimms[i] <- length(unique(p[j]))
      dimm <- dimm+dimms[i]
    }
    tmat <- matrix(0,dimm,4*s)
    for(i in 1:s){
      ttemp <- matrix(0,dimms[i],4)
      if(dimms[i]==4){
        diag(ttemp) <- rep(1,4)
      }
      else{
        ptemp <- p[(1:4)+4*(i-1)]
        ptempunik <- unique(ptemp)
        for(j in 1:dimms[i]){
          ttemp[j,ptemp==ptempunik[j]] <- 1
        }
      }
      tmat[(1:dimms[i])+sum(dimms[0:(i-1)]),(1:4)+4*(i-1)] <- ttemp
    }
  }
  list(tmat=tmat,ms=dimms)
}

ttransform <- function(p1,p2){
  tmat(mixp(p1,p2)) 
}

